 
 /*     
    scan.h - part of horus
    
  */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <signal.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <time.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/icmp.h>

#define TRUE		1
#define FALSE		0
#define MAXTRIES	5

static int timed_out;
static int tokens;
  
unsigned short csum(unsigned short *buffer, int i)
    {
	register long sum;
        unsigned short  oddbyte;
        register unsigned short return_val;   
        sum = 0;
	while (i > 1)  { sum += *buffer++; i -= 2; }
	if (i == 1) {
                oddbyte = 0;   
                *((u_char *)&oddbyte) = *(u_char *)buffer;  
                sum += oddbyte;
        }
 
        sum  = (sum >> 16) + (sum & 0xffff);
        sum += (sum >> 16);          
        return_val = ~sum;          
        return(return_val);
    }

unsigned nr(char *hostname){
    struct hostent *he;
    struct in_addr address;
    if((address.s_addr=inet_addr(hostname))==-1){
     	if(!(he=gethostbyname(hostname))){
            fprintf(stderr,"Couldn't resole hostname: %s\n",hostname);
            exit(0);
      	    }
      	bcopy(he->h_addr,(char *)&address.s_addr,he->h_length);
   	}
    return(address.s_addr);
}

void catch(int sig){
    timed_out = TRUE;
}

int syn(unsigned int port, char *from, char *to)
    {

    int raw_sock = socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
    int i = 1;
    struct sockaddr_in sin;

    unsigned target, dummy;

   	struct packet{
      	    struct iphdr ip;
      	    struct tcphdr tcp;
   	    } packet;
   
	struct pseudo_header{
      	    unsigned int source_address;
      	    unsigned int dest_address;
    	    unsigned char placeholder;
      	    unsigned char protocol;
      	    unsigned short tcp_length;
      	    struct tcphdr tcp;
   	    } pseudo_header;
 
    unsigned short sport;

    if (raw_sock < 0){
	fprintf (stderr, "! ERROR: couldn't send SYN packets (tip: use a delay)\n\n");
	exit(666);
        }
        
    sport = 1 + (int)(65535.0*rand()/(RAND_MAX+1.0));    
    
    if (sport == tokens) sport += rand();    
    tokens = sport;	
    

    target = nr(to);
    dummy  = nr(from);

    sin.sin_family = AF_INET;
    sin.sin_port   = sport;
    sin.sin_addr.s_addr = target;
    
    packet.tcp.source = sport;	
    packet.tcp.dest   = htons(port); 
    packet.tcp.seq    = 1 + (int)(65535.0*rand()/(RAND_MAX+1.0));
    packet.tcp.ack_seq= 0;    packet.tcp.doff   = 0;
    packet.tcp.res1   = 0;    packet.tcp.res2   = 0;		
    packet.tcp.urg    = 0;    packet.tcp.ack    = 0;	
    packet.tcp.psh    = 0;    packet.tcp.rst    = 0;	
    packet.tcp.syn    = 1;    packet.tcp.fin    = 0;		
    packet.tcp.window = 1 + (int)(65535.0*rand()/(RAND_MAX+1.0));    
    packet.tcp.check  = 0;    packet.tcp.urg_ptr= 0;
   
    packet.ip.version = 4;    packet.ip.ihl     = 5;	
    packet.ip.tos     = 0;    packet.ip.tot_len = htons(40);	
    packet.ip.id      = getpid();    packet.ip.frag_off= 0;	
    packet.ip.ttl     = 255;  packet.ip.protocol= IPPROTO_TCP; 
    packet.ip.check   = 0;		

    packet.ip.saddr   = dummy;   packet.ip.daddr   = target;
      		
    pseudo_header.source_address = packet.ip.saddr;
    pseudo_header.dest_address   = packet.ip.daddr;
    pseudo_header.placeholder    = 0;
    pseudo_header.protocol       = IPPROTO_TCP;
    pseudo_header.tcp_length     = htons(20);
 
    packet.ip.check = csum((unsigned short *)&packet.ip, 20);
    bcopy((char *)&packet.tcp,(char *)&pseudo_header.tcp, 20);
    packet.tcp.check= csum((unsigned short *)&pseudo_header.tcp, 32);
    
    if (setsockopt(raw_sock, IPPROTO_IP, IP_HDRINCL, (char *)&i, sizeof(i)) < 0){
	fprintf (stderr, "setsockopt() error");
	exit(666);
	}

    if (sendto(raw_sock, &packet, sizeof(packet), 0, (struct sockaddr *)&sin, sizeof(sin)) != sizeof(packet)){
	perror(" sendto() error");
	exit(666);
	}
    }        

int nping(char *dummy)
    {

    int raw_sock = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP);

    void catch(int);
    static struct sigaction act, oact;

    int i, ntries;
    struct icmphdr *icmp;
    struct sockaddr_in sin;
    unsigned char  packet[4096] = {0};
    unsigned short ident = getpid() & 0xffff;

    struct ippkt{
	struct iphdr ip;
	struct icmphdr icmp;
	char buffer[4096];
    }pkt;

    if (raw_sock < 0){
	fprintf (stderr, "Error: problem with the ICMP socket\n\n");
	exit(666);
        }

    bzero((char *)&sin,sizeof(sin));
    
    sin.sin_family = AF_INET;
    sin.sin_addr.s_addr=nr(dummy);

    icmp=(struct icmphdr *)packet;
    
    icmp->type=ICMP_ECHO;
    icmp->code=0;
    icmp->un.echo.id = ident;
    icmp->un.echo.sequence = 0;
    icmp->checksum = csum((unsigned short *)icmp,64);

    i = sendto(raw_sock,packet,64,0,(struct sockaddr *)&sin,sizeof(sin));

    if (i < 0 || i != 64){
	if (i < 0) perror("sendto: ");
	printf ("* ping: %d returned %d bytes", dummy, i);
	exit(i);
        }

    act.sa_handler = catch;
    sigaction(SIGALRM, &act, &oact);

    for (ntries = 0; ntries < MAXTRIES; ntries++){
	timed_out = FALSE;
	alarm(5);
	read(raw_sock,(struct ippkt *)&pkt,4095);
	alarm(0);
	if (!timed_out) break;
  	}
	
    sigaction(SIGALRM, &oact, NULL);
    
    close(raw_sock);
    
    if (ntries < MAXTRIES){ 
	if(pkt.icmp.type==ICMP_ECHOREPLY && icmp->un.echo.id == ident)
	    return(1);
	else
	    return(0);
	}
    else
	return(0);	
    }

int sping(char *dummy, unsigned int sekwens)
    {

    int raw_sock = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP);

    int i;
    struct icmphdr *icmp;
    struct sockaddr_in sin;
    unsigned char  packet[4096] = {0};
    unsigned short ident = getpid() & 0xffff;
    
    struct ippkt{
   	struct iphdr ip;
   	struct icmphdr icmp;
   	char buffer[4096];
    }pkt;

    if (raw_sock < 0){
	fprintf (stderr, "Error: problem with the ICMP socket\n\n");
	exit(666);
        }

    bzero((char *)&sin,sizeof(sin));
    
    sin.sin_family = AF_INET;
    sin.sin_addr.s_addr=nr(dummy);

    icmp=(struct icmphdr *)packet;    
    icmp->type=ICMP_ECHO;
    icmp->code=0;
    icmp->un.echo.id = ident;
    icmp->un.echo.sequence = sekwens;
    icmp->checksum = csum((unsigned short *)icmp,64);

    i = sendto(raw_sock,packet,64,0,(struct sockaddr *)&sin,sizeof(sin));

    if (i < 0 || i != 64){
	if (i < 0) perror("sendto: ");
	printf ("ping: %d returned %d bytes", dummy, i);    
        }
            
    while(1){	
	read(raw_sock,(struct ippkt *)&pkt,4095);
  	if(pkt.icmp.type==ICMP_ECHOREPLY)
	     return(icmp->un.echo.sequence);    
	}
    }

